import acm.graphics.*;
import acm.program.*;
import java.awt.event.*;

public class Blockade extends GraphicsProgram {

	/* Initializes the graphics state */
	public void init() {
		nextX = getWidth() / 2;
		nextY = getHeight() / 2;
		dir = RIGHT;
		addMouseListeners();
	}
	
	/* Runs the simulation */
	public void run() {
		
		waitForClick();
		
		while (getElementAt(nextX, nextY) == null) {
			drawSnakeUnit();
			updateSnakeHeadLocation();
			pause(PAUSE_TIME);
		}
		
	}
	
	private void drawSnakeUnit () {
		GRect rect = new GRect(SQUARE_SIZE, SQUARE_SIZE);
		rect.setFilled(true);
		add(rect, nextX - SQUARE_SIZE / 2, nextY - SQUARE_SIZE /2);
	}
	
	private void updateSnakeHeadLocation() {
		switch (dir) {
			case UP: nextY -= SQUARE_SIZE; break;
			case RIGHT: nextX += SQUARE_SIZE; break;
			case DOWN: nextY += SQUARE_SIZE; break;
			case LEFT: nextX -= SQUARE_SIZE; break;
		}
	}
	

	/* Reacts to a mouse-pressed event */
	public void mousePressed(MouseEvent e) {
		if (dir == UP || dir == DOWN) {
			dir = (e.getX()  > nextX) ? RIGHT : LEFT;
		}
		else {
			dir = (e.getY()  > nextY) ? DOWN : UP;
		}
	}
	
	/* Instance variables*/
	private double nextX;
	private double nextY;
	private int dir;
	
	/* Private constants*/
	private static final int UP = 0;
	private static final int RIGHT = 1;
	private static final int DOWN = 2;
	private static final int LEFT = 3;
	
	private static final int PAUSE_TIME = 100;
	private static final double SQUARE_SIZE = 15;
	
}