import acm.graphics.*;
import acm.program.*;
import java.awt.event.*;

/**
 * This is the solution from Lucas Garron's CS106A section
 * 3:15PM, Wednesday, April 21, 2010
 * Gates 100, Stanford
 *
 * I suggest playing around with this code before working on Breakout. Some suggestions:
 * 
 * - Play around with changing all the constants. Will the program still work?
 * - Draw each block with a random color. You'll want to add "rect.setColor(rgen.nextColor());" but what else do you need?
 * - Practice taking code from a method and decomposing it. I suggest doing this for the block drawing code.
 * - Rewrite mousePressed() using "if(...) {...} else {...}" statements to make sure you understand it.
 *
 * - Limit the snake to moving only on the game screen. (Good practice for Breakout!)
 * - Change/add controls for the game?
 * - When the snake crashes, write "GAME OVER" on the screen so it's clear to the player. (This sort of thing could be a little "extra credit" for Breakout.) 
 */

public class BlockadeSectionSolution extends GraphicsProgram {

        /** Initializes the graphics state. */
        public void init() {
            
        	//Set up the values that describe the game
            x = getWidth()/2 - BOX_WIDTH/2;
            y = getHeight()/2 - BOX_HEIGHT/2;
            dir = RIGHT;
            
            addMouseListeners();
        }
        
        /** Runs the snake simulation. */
        public void run() {
        	//While there isn't already a block where you are, keep going.
            while(getElementAt(x, y) == null) {
                
            	//Draw the current block. This would be good to decompose, especially if you expand it with fancier drawing.
                GRect rect = new GRect(x, y, BOX_WIDTH, BOX_HEIGHT);
        		rect.setFilled(true);
                add(rect);
                
                updateSnakeHeadLocation();
    
    			pause(PAUSE_TIME);
            }
        }
        
        /** Checks the value of dir (the current direction )to update the snake location. */
        private void updateSnakeHeadLocation() {
            switch (dir) {
                case UP: y += BOX_HEIGHT; break;
                case RIGHT: x += BOX_WIDTH; break;
                case DOWN: y -= BOX_HEIGHT; break;
                case LEFT: x -= BOX_WIDTH; break;
            }
        }
        
        /** Decide how to move when the mouse is pressed. */
        public void mousePressed(MouseEvent e) {
             if (dir == UP || dir == DOWN) {
                        dir = (e.getX()  > x) ? RIGHT : LEFT;
                }
                else {
                        dir = (e.getY()  > y) ? UP : DOWN;
                }
        }


        /* Private Variables */
        private static int dir;
        private static int x;
        private static int y;

        
        /* Private constants */
        private static final int UP = 0;
        private static final int RIGHT = 1;
        private static final int DOWN = 2;
        private static final int LEFT = 7;
        
        private static final int BOX_WIDTH = 15;
        private static final int BOX_HEIGHT = 15;

    	private static final int PAUSE_TIME = 100;
}
