import java.awt.Color;
import acm.graphics.*;
import acm.program.*;
import acm.util.RandomGenerator;

public class RandomDoughnuts extends GraphicsProgram {
	public void run() {
		for (int i = 0; i < N_CIRCLES; i++) {
			addRandomDoughnut();
		}
	}

	private void addRandomDoughnut() {
		double outerRadius = rgen.nextDouble(MIN_RADIUS, MAX_RADIUS);
		double holeRadius = outerRadius - DOUGHNUT_SIZE;
		double x = rgen.nextDouble(0, getWidth() - 2 * outerRadius);
		double y = rgen.nextDouble(0, getHeight() - 2 * outerRadius);

		GOval circle = new GOval(x, y, 2 * outerRadius, 2 * outerRadius);
		circle.setFilled(true);
		circle.setColor(rgen.nextColor());
		
		GOval hole = new GOval(x + DOUGHNUT_SIZE, y + DOUGHNUT_SIZE, 2 * holeRadius, 2 * holeRadius);

		hole.setFilled(true);
		hole.setColor(Color.WHITE);

		add(circle);
		add(hole);

	}

	/* Instance variable */
	private RandomGenerator rgen = new RandomGenerator();

	/* Private constants */
	private static final int N_CIRCLES = 10;
	private static final double MIN_RADIUS = 50;
	private static final double MAX_RADIUS = 150;
	private static final int DOUGHNUT_SIZE = 50;
}